local Auras = {
	-- death knight
	--[79092] = "Hungering Cold1",
	--[51209] = "Hungering Cold2",
	--[49203] = "Hungering Cold3",
	-- you know what, screw hungering cold
	-- druid
	[339] = "Entangling Roots", -- we should probably ignore damage caused by the roots
	[2637] = "Hibernate",
	--[33786] = "Cyclone", -- unbreakable
	-- hunter
	[3355] = "Freezing Trap",
	--[19503] = "Scatter Shot",
	[19386] = "Wyvern Sting",
	[1513] = "Scare Beast",
	-- mage
	[118] = "Polymorph (Sheep)",
	[61305] = "Polymorph (Black Cat)",
	[28272] = "Polymorph (Pig)",
	[61721] = "Polymorph (Rabbit)",
	[61780] = "Polymorph (Turkey)",
	[28271] = "Polymorph (Turtle)",
	--[31661] = "Dragon's Breath",
	[82691] = "Ring of Frost",
	-- paladin
	[10326] = "Turn Evil",
	[20066] = "Repentance",
	-- priest
	[9484] = "Shackle Undead",
	[8122] = "Psychic Scream",
	--[64044] = "Psychic Horror",
	--[88625] = "Holy Word: Chastise",
	-- rogue
	[6770] = "Sap",
	--[1776] = "Gouge",
	[2094] = "Blind",
	-- shaman
	[51514] = "Hex",
	[76780] = "Bind Elemental",
	-- warlock
	[5782] = "Fear",
	--[710] = "Banish", -- unbreakable
	[5484] = "Howl of Terror",
	--[6789] = "Death Coil",
	[6358] = "Seduction",
	-- warrior
	[5246] = "Intimidating Shout Indirect",
	[20511] = "Intimidating Shout Direct",
}

local function Say(msg)
	ChatFrame1:AddMessage("|cffff00ff[Instigator]:|r "..msg)
end

local Addon = CreateFrame("Frame")
Addon:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, ...) end end)

local Victims = {
	-- [guid] = {
	--  	LastDamage = {timestamp, source name, spell name},
	--  	Auras = {
	--  		spellId = timestamp? i don't know, whatever.
	--  	},
	-- }
}

local function ApplyAura(guid, spellId, dstName)
	if not Victims[guid] then
		Victims[guid] = {
			Name = dstName or "Unknown",
			LastDamage = {timestamp = 0},
			Auras = {},
		}
	end
	Victims[guid].Auras[spellId] = GetTime()
end

local function RemoveAura(guid, spellId, srcName, spellName)
	if not Victims[guid] then return end
	if not Victims[guid].Auras[spellId] then return end
	if Victims[guid].MarkedForRemoval and Victims[guid].MarkedForRemoval.spellId == spellId then
		Victims[guid].MarkedForRemoval = nil
	end
	Victims[guid].Auras[spellId] = nil
	local AuraLink = GetSpellLink(spellId) or "CC"
	if srcName and spellName then
		Say(format("|cffaaffaa%s|r removed %s from |cffffaaaa%s|r with %s", srcName or "Unknown", AuraLink, Victims[guid].Name, spellName or "something"))
	else
		Say(format("%s removed from |cffffaaaa%s|r", AuraLink, Victims[guid].Name))
	end
end

local threshold = 0.5 -- amount of time before or after CC is removed to check for damage events to assign blame
local function RemoveAuraPrep(guid, spellId) -- THIS IS A TERRIBLE WAY TO DO THIS OH GOD WHY AM I DOING THIS
	if not Victims[guid] then return end
	local AuraLink = GetSpellLink(spellId)
	if GetTime() - Victims[guid].LastDamage.timestamp <= threshold and Victims[guid].LastDamage.spellName ~= AuraLink then
		RemoveAura(guid, spellId, Victims[guid].LastDamage.srcName, Victims[guid].LastDamage.spellName)
	else
		Victims[guid].MarkedForRemoval = {timestamp = GetTime(), spellId = spellId}
		--Say(format("%s removed from |cffffaaaa%s|r", AuraLink, Victims[guid].Name))
	end
end

local function WhatDoesThisEvenDoAnyway(guid, srcName, spellName)
	if not Victims[guid] then return end
	if Victims[guid].MarkedForRemoval then
		if GetTime() - Victims[guid].MarkedForRemoval.timestamp <= threshold then
			RemoveAura(guid, Victims[guid].MarkedForRemoval.spellId, srcName, spellName)
		end
		Victims[guid].MarkedForRemoval = nil
	else
		Victims[guid].LastDamage = {timestamp = GetTime(), srcName = srcName, spellName = spellName}
	end
end

local function Pet2Player(guid)
	if UnitInRaid("player") then
		for i=1,40 do
			if guid == UnitGUID("raidpet"..i) then
				return UnitName("raid"..i), UnitCreatureFamily("raidpet"..i)
			end
		end
	else
		if guid == UnitGUID("pet") then return UnitName("player"), UnitCreatureFamily("pet") end
		for i=1,4 do
			if guid == UnitGUID("partypet"..i) then
				return UnitName("party"..i), UnitCreatureFamily("partypet"..i)
			end
		end
	end
	return false
end

Addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
function Addon:COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, ...)
	local SpellName = false
	
	if bit.band(srcFlags, COMBATLOG_OBJECT_TYPE_PET) ~= 0 and bit.band(srcFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) == 0 then
		local owner, petFamily = Pet2Player(srcGUID)
		if owner then
			if petFamily then
				srcName = owner .. "'s " .. petFamily
			else
				srcName = owner .. "'s pet"
			end
		end
	end
	
	if event == "SWING_DAMAGE" then
		SpellName = "auto attack"
	elseif event == "RANGE_DAMAGE" then
		SpellName = "auto shot"
	elseif event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" then
		SpellName = GetSpellLink(spellId) or select(1,...) or "something"
	elseif event == "ENVIRONMENTAL_DAMAGE" then -- maybe they fell into a volcano or something
		SpellName = spellId or "How I Learned to Stop Worrying and Love the Bomb"
	elseif event == "SPELL_AURA_APPLIED" and Auras[spellId] and bit.band(srcFlags, COMBATLOG_OBJECT_AFFILIATION_OUTSIDER) == 0 then
		ApplyAura(dstGUID, spellId, dstName)
	elseif event == "SPELL_AURA_REMOVED" and Auras[spellId] then
		RemoveAuraPrep(dstGUID, spellId) -- order of events??
	elseif event == "SPELL_AURA_BROKEN" and Auras[spellId] then
		RemoveAura(dstGUID, spellId, srcName, "auto attack")
	elseif event == "SPELL_AURA_BROKEN_SPELL" and Auras[spellId] then
		local extraSpellId = select(3,...)
		local spellName = GetSpellLink(extraSpellId) or "auto attack"
		RemoveAura(dstGUID, spellId, srcName, spellName)
	elseif event == "SPELL_DISPEL" then
		local extraSpellId = select(3,...) or 0
		local spellLink = GetSpellLink(extraSpellId)
		-- spellId = dispel
		-- extraSpellId = aura
		RemoveAura(dstGUID, extraSpellId, srcName, spellLink)
	elseif event == "UNIT_DIED" then
		Victims[dstGUID] = nil
	end
	
	if SpellName then
		WhatDoesThisEvenDoAnyway(dstGUID, srcName, SpellName)
	end
end